local metadata = {
"## Interface:FS15 1.2",
"## Title: UniversalManipulate",
"## Notes: Manipuliert LS15 Werte",
"## Author: HappyLooser",
"## Version: 0.3",
"## Date: Begin 3.1.2015",
"## Web: no",
"## Info: Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt"
} 

print("---loading UniversalManipulate v0.3 (by HappyLooser)---")
local manipulateType = "";
local groupTag = "UniversalManipulate.";
local groupType = "";
local groupSpecification = "";
local groupPath = "";
local acceptTypes = "";
local automaticSettings = "";
local autoFruitRegister = "";
local manipulateLogTypes = "";
local Xml;

function loadConfig()
	local path = getUserProfileAppPath();
	local file = path.."/universalManipulateSettings.xml";
	local firstStart = true;
	print("loading "..file.." for UniversalManipulate settings");
	if fileExists(file) then
		local createPhantom = "";
		Xml = loadXMLFile("universalManipulateSettings_XML", file, "UniversalManipulate");		
		if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") == nil then
			setXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion", false);
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateTrailers") == nil then			
			setXMLBool(Xml, "UniversalManipulate.Config.ManipulateTrailers", false);
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateSowings") == nil then			
			setXMLBool(Xml, "UniversalManipulate.Config.ManipulateSowings", false);				
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateShovels") == nil then			
			setXMLBool(Xml, "UniversalManipulate.Config.ManipulateShovels", false);				
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateCutters") == nil then			
			setXMLBool(Xml, "UniversalManipulate.Config.ManipulateCutters", false);				
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateTrailers") then			
			createPhantomAndAccepts("Trailers");
			createPhantom = createPhantom .." Trailers";
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateSowings") then			
			createPhantomAndAccepts("Sowings");
			createPhantom = createPhantom .." Sowings";
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateShovels") then			
			createPhantomAndAccepts("Shovels");
			createPhantom = createPhantom .." Shovels";
		end;
		if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateCutters") then			
			createPhantomAndAccepts("Cutters");
			createPhantom = createPhantom .." Cutters";
		end;
		if string.len(createPhantom) >= 3 then
			print("----Universal Manipulate: update Phantom_.... accepts values for:" ..createPhantom .."----");
		end;
		firstStart = false;
	else
		print("creating "..file.." for UniversalManipulate settings");
		Xml = createXMLFile("UniversalManipulateSettings_XML", file, "UniversalManipulate");		
		setXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion", false);
		setXMLBool(Xml, "UniversalManipulate.Config.ManipulateTrailers", false);
		setXMLBool(Xml, "UniversalManipulate.Config.ManipulateSowings", false);
		setXMLBool(Xml, "UniversalManipulate.Config.ManipulateShovels", false);
		setXMLBool(Xml, "UniversalManipulate.Config.ManipulateCutters", false);
	end;
	saveXMLFile(Xml);	
	Xml = loadXMLFile("universalManipulateSettings_XML", file, "UniversalManipulate");
	if not firstStart and not getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
		setManipulation();
	end;
end;

function createPhantomAndAccepts(typeName)
	if typeName == "Trailers" then
		groupType = typeName ..".";
		local completionNames = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");
		if completionNames == nil then
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here trailer name");
		elseif string.find(completionNames, "here trailer name") == nil then
			if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
				automaticSettings = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");				
				automaticCompletionSettings(automaticSettings);				
			end;
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here trailer name");
		end;	
		local manipulateNames = getXMLString(Xml, groupTag.. groupType.."Names");
		if manipulateNames == nil then				
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Trailer,");	
		elseif string.find(manipulateNames, "Phantom Trailer,") == nil then
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Trailer," ..manipulateNames);
		end;
		setXMLString(Xml, groupTag.. groupType.."Phantom_Trailer.fillTypes", "wheat,rape,maize,barley,chaff,potato,sugarBeet,silage,woodChips,forage,barley_windrow,wheat_windrow,grass_windrow,manure,kalk,seeds,seeds2,forage_mixing,fuel,water,liquidManure,milk,");
		setXMLInt(Xml, groupTag.. groupType.."Phantom_Trailer.capacity", 0);
		setXMLInt(Xml, groupTag.. groupType.."Phantom_Trailer.overloadingCapacity", 0);
	end;
	if typeName == "Sowings" then
		groupType = typeName ..".";
		local completionNames = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");
		if completionNames == nil then
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here sowing name");
		elseif string.find(completionNames, "here trailer name") == nil then
			if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
				automaticSettings = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");				
				automaticCompletionSettings(automaticSettings);				
			end;
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here sowing name");
		end;	
		local manipulateNames = getXMLString(Xml, groupTag.. groupType.."Names");
		if manipulateNames == nil then					
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Sowing,");
		elseif 	string.find(manipulateNames, "Phantom Sowing,") == nil then
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Sowing," ..manipulateNames);
		end;
		setXMLString(Xml, groupTag.. groupType.."Phantom_Sowing.fillTypes", "potato,sugarBeet,seeds,seeds2,");
		setXMLString(Xml, groupTag.. groupType.."Phantom_Sowing.seedFruitTypes", "wheat,barley,rape,maize,potato,sugarBeet,grass,klee,luzerne,");
		setXMLInt(Xml, groupTag.. groupType.."Phantom_Sowing.capacity", 0);
		setXMLBool(Xml, groupTag.. groupType.."Phantom_Sowing.useDirectPlanting", false);	
	end;
	if typeName == "Shovels" then
		groupType = typeName ..".";
		local completionNames = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");
		if completionNames == nil then
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here shovel name");
		elseif string.find(completionNames, "here shovel name") == nil then
			if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
				automaticSettings = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");				
				automaticCompletionSettings(automaticSettings);				
			end;
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here shovel name");
		end;	
		local manipulateNames = getXMLString(Xml, groupTag.. groupType.."Names");
		if manipulateNames == nil then				
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Shovel,");	
		elseif string.find(manipulateNames, "Phantom Shovel,") == nil then
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Shovel," ..manipulateNames);
		end;
		setXMLString(Xml, groupTag.. groupType.."Phantom_Shovel.fillTypes", "wheat,rape,maize,barley,chaff,potato,sugarBeet,silage,woodChips,forage,barley_windrow,wheat_windrow,grass_windrow,manure,kalk,seeds,seeds2,forage_mixing,");
		setXMLInt(Xml, groupTag.. groupType.."Phantom_Shovel.capacity", 0);		
	end;
	if typeName == "Cutters" then
		groupType = typeName ..".";
		local completionNames = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");
		if completionNames == nil then
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here cutter name");
		elseif string.find(completionNames, "here cutter name") == nil then
			if getXMLBool(Xml, "UniversalManipulate.Config.AutomaticCompletion") then
				automaticSettings = getXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName");				
				automaticCompletionSettings(automaticSettings);				
			end;
			setXMLString(Xml, groupTag.. groupType.."AutomaticCompletionName", "here cutter name");
		end;	
		local manipulateNames = getXMLString(Xml, groupTag.. groupType.."Names");
		if manipulateNames == nil then				
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Cutter,");	
		elseif string.find(manipulateNames, "Phantom Cutter,") == nil then
			setXMLString(Xml, groupTag.. groupType.."Names", "Phantom Cutter," ..manipulateNames);
		end;
		setXMLString(Xml, groupTag.. groupType.."Phantom_Cutter.fruitTypes", "wheat,rape,maize,barley,potato,sugarBeet,grass,luzerne,klee,");
		--setXMLInt(Xml, groupTag.. groupType.."Phantom_Cutter.speedLimit", 0);
	end;
	saveXMLFile(Xml);
end;

function automaticCompletionSettings(automaticSettingsName)
	local automatic = Utils.splitString(",", automaticSettingsName);
	local settingsOkay = false;
	local autoName = "";
	for _,k in pairs(automatic) do		
		if k ~= nil and string.len(k) >= 2 then			
			local settingsNames = getXMLString(Xml, groupTag.. groupType.."Names");							
			if groupType == "Trailers." and k ~= "here trailer name" and string.find(settingsNames, k ..",") == nil then
				autoName = autoName .." " ..k
				local replaceName = string.gsub(k, " ", "_");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fillTypes", "fillTypeName,fillTypeName,");
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".capacity", 0);
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".overloadingCapacity", 0);
				setXMLString(Xml, groupTag.. groupType.."Names", k.."," ..settingsNames);
				settingsOkay = true;										
			end;
			if groupType == "Sowings." and k ~= "here sowing name" and string.find(settingsNames, k ..",") == nil then
				autoName = autoName .." " ..k
				local replaceName = string.gsub(k, " ", "_");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fillTypes", "fillTypeName,fillTypeName,");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".seedFruitTypes", "seedFruitTypeName,seedFruitTypeName,");
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".capacity", 0);
				setXMLBool(Xml, groupTag.. groupType.. replaceName..".useDirectPlanting", false);				
				setXMLString(Xml, groupTag.. groupType.."Names", k.."," ..settingsNames);
				settingsOkay = true;										
			end;
			if groupType == "Shovels." and k ~= "here shovel name" and string.find(settingsNames, k ..",") == nil then
				autoName = autoName .." " ..k
				local replaceName = string.gsub(k, " ", "_");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fillTypes", "fillTypeName,fillTypeName,");				
				setXMLInt(Xml, groupTag.. groupType.. replaceName..".capacity", 0);				
				setXMLString(Xml, groupTag.. groupType.."Names", k.."," ..settingsNames);
				settingsOkay = true;										
			end;
			if groupType == "Cutters." and k ~= "here cutter name" and string.find(settingsNames, k ..",") == nil then
				autoName = autoName .." " ..k
				local replaceName = string.gsub(k, " ", "_");
				setXMLString(Xml, groupTag.. groupType.. replaceName..".fruitTypes", "fruitTypeName,fruitTypeName,");
				--setXMLInt(Xml, groupTag.. groupType.. replaceName..".speedLimit", 0);
				setXMLString(Xml, groupTag.. groupType.."Names", k.."," ..settingsNames);
				settingsOkay = true;										
			end;
		end;		
	end;
	if settingsOkay then
		print("automatic completion settings for names:" ..autoName);	
	end;
end;

function autoFruitRegister()
end;

function setManipulation()	
	if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateTrailers") then
		trailerManipulation();
	end;
	if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateSowings") then
		sowingManipulation();
	end;
	if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateShovels") then
		shovelManipulation();
	end;
	if getXMLBool(Xml, "UniversalManipulate.Config.ManipulateCutters") then
		cutterManipulation();
	end;
end;

function trailerManipulation()	
	local oldTrailerLoad = Trailer.load;	
	Trailer.load = function(self, xmlFile)	
		oldTrailerLoad(self, xmlFile);
		groupType = "Trailers.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then				
				groupSpecification = ".fillTypes";
				groupPath = checkAll(3, replaceName, false);				
				acceptTypes = Utils.splitString(",", getXMLString(Xml, groupTag.. groupType.."Phantom_Trailer.fillTypes"));
				for _,v in pairs(acceptTypes) do				
					if groupPath ~= nil then						
						groupSpecification = getXMLString(Xml, groupPath);
						if groupSpecification ~= nil and string.len(groupSpecification) >= 2 then													
							local fillType = Fillable.fillTypeNameToInt[v];	
							local upperManipulateFillTypes = groupSpecification;
							local foundFillTypesName =	string.find(upperManipulateFillTypes, v ..",");
							if fillType ~= nil and self.fillTypes[fillType] == nil and foundFillTypesName ~= nil then								
								self.fillTypes[fillType] = true;								
							end;					
						end;
					end;								
				end;
				groupSpecification = ".capacity";
				groupPath = checkAll(3, replaceName, false);	
				if groupPath ~= nil then
					groupSpecification = getXMLInt(Xml, groupPath);	
					if self.capacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
						self.capacity = groupSpecification;						
					end;
				end;
				groupSpecification = ".overloadingCapacity";
				groupPath = checkAll(3, replaceName, false);
				if groupPath ~= nil then
					groupSpecification = getXMLInt(Xml, groupPath);	
					if self.overloadingCapacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
						self.overloadingCapacity = groupSpecification;						
					end;
				end;			
			end;		
		end;	
	end;	
end;

function sowingManipulation()	
	local oldSowingMachineLoad = SowingMachine.load;	
	SowingMachine.load = function(self, xmlFile)	
		oldSowingMachineLoad(self, xmlFile);
		groupType = "Sowings.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then				
				groupSpecification = ".fillTypes";
				groupPath = checkAll(3, replaceName, false);				
				acceptTypes = Utils.splitString(",", getXMLString(Xml, groupTag.. groupType.."Phantom_Sowing.fillTypes"));
				for _,v in pairs(acceptTypes) do				
					if groupPath ~= nil then						
						groupSpecification = getXMLString(Xml, groupPath);
						if groupSpecification ~= nil and string.len(groupSpecification) >= 2 then							
							local fillType = Fillable.fillTypeNameToInt[v];							
							local upperManipulateFillTypes = groupSpecification;
							local foundFillTypesName =	string.find(upperManipulateFillTypes, v ..",");
							if fillType ~= nil and self.fillTypes[fillType] == nil and foundFillTypesName ~= nil then
								self.fillTypes[fillType] = true;								
							end;					
						end;
					end;								
				end;
				groupSpecification = ".seedFruitTypes";
				groupPath = checkAll(3, replaceName, false);
				acceptTypes = Utils.splitString(",", getXMLString(Xml, groupTag.. groupType.."Phantom_Sowing.seedFruitTypes"));
				for _,v in pairs(acceptTypes) do				
					if groupPath ~= nil then						
						groupSpecification = getXMLString(Xml, groupPath);
						if groupSpecification ~= nil and string.len(groupSpecification) >= 2 then
							fruitTypeDesc = FruitUtil.fruitTypes[v];							
							local upperManipulateFruitTypes = groupSpecification;
							local foundFruitTypesName =	string.find(upperManipulateFruitTypes, v ..",");							
							if fruitTypeDesc ~= nil and self.seeds[fruitTypeDesc] == nil and foundFruitTypesName ~= nil and v ~= fruitTypeDesc.index then
								table.insert(self.seeds, FruitUtil.fruitTypes[v].index);								
							end;					
						end;
					end;								
				end;
				groupSpecification = ".capacity";
				groupPath = checkAll(3, replaceName, false);	
				if groupPath ~= nil then
					groupSpecification = getXMLInt(Xml, groupPath);	
					if self.capacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
						self.capacity = groupSpecification;						
					end;
				end;				
				groupSpecification = ".useDirectPlanting";
				groupPath = checkAll(3, replaceName, false);	
				if groupPath ~= nil then
					groupSpecification = getXMLBool(Xml, groupPath);	
					if self.useDirectPlanting ~= nil and groupSpecification ~= nil then 
						self.useDirectPlanting = groupSpecification;						
					end;
				end;
			end;		
		end;	
	end;	
end;

function shovelManipulation()	
	local oldShovelLoad = Shovel.load;	
	Shovel.load = function(self, xmlFile)	
		oldShovelLoad(self, xmlFile);
		groupType = "Shovels.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");		
		if self.name ~= nil and checkAll(1, self.name, false) then			
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then
				groupSpecification = ".fillTypes";
				groupPath = checkAll(3, replaceName, false);				
				acceptTypes = Utils.splitString(",", getXMLString(Xml, groupTag.. groupType.."Phantom_Shovel.fillTypes"));
				for _,v in pairs(acceptTypes) do				
					if groupPath ~= nil then
						groupSpecification = getXMLString(Xml, groupPath);
						if groupSpecification ~= nil and string.len(groupSpecification) >= 2 then													
							local fillType = Fillable.fillTypeNameToInt[v];	
							local upperManipulateFillTypes = groupSpecification;
							local foundFillTypesName =	string.find(upperManipulateFillTypes, v ..",");							
							if fillType ~= nil and self.fillTypes[fillType] == nil and foundFillTypesName ~= nil then
								self.fillTypes[fillType] = true;								
							end;					
						end;
					end;								
				end;
				groupSpecification = ".capacity";
				groupPath = checkAll(3, replaceName, false);	
				if groupPath ~= nil then
					groupSpecification = getXMLInt(Xml, groupPath);	
					if self.capacity ~= nil and groupSpecification ~= nil and groupSpecification > 0 then 
						self.capacity = groupSpecification;						
					end;
				end;				
			end;		
		end;	
	end;	
end;

function cutterManipulation()	
	local oldCutterLoad = Cutter.load;	
	Cutter.load = function(self, xmlFile)	
		oldCutterLoad(self, xmlFile);
		groupType = "Cutters.";
		manipulateType = getXMLString(Xml, groupTag.. groupType.."Names");			
		if self.name ~= nil and checkAll(1, self.name, false) then
			local replaceName = checkAll(2, self.name, false);					
			if replaceName ~= nil then				
				groupSpecification = ".fruitTypes";
				groupPath = checkAll(3, replaceName, false);				
				acceptTypes = Utils.splitString(",", getXMLString(Xml, groupTag.. groupType.."Phantom_Cutter.fruitTypes"));
				for _,v in pairs(acceptTypes) do				
					if groupPath ~= nil then						
						groupSpecification = getXMLString(Xml, groupPath);
						if groupSpecification ~= nil and string.len(groupSpecification) >= 2 then
							local fruitType = FruitUtil.fruitTypes[v];	
							local upperManipulateFruitTypes = groupSpecification;
							local foundFruitTypesName =	string.find(upperManipulateFruitTypes, v ..",");							
							if fruitType ~= nil and self.fruitTypes[fruitType] == nil and foundFruitTypesName ~= nil then								
								table.insert(self.fruitTypes, FruitUtil.fruitTypes[v].index);
								self.fruitTypes[fruitType.index] = true;
								local outputDesc = "chaff";
								self.convertedFruits[fruitType.index] = outputDesc.index;								
							end;					
						end;
					end;								
				end;				
			end;		
		end;	
	end;	
end;

function checkAll(int, manipulate, typesExtra)	
	if int == 1 and manipulateType ~= nil and string.find(manipulateType, manipulate ..",", 0, true) ~= nil then		
		return true;
	end;
	if int == 2 then
		return string.gsub(manipulate, " ", "_");
	end;
	if int == 3 then
		return groupTag ..groupType ..manipulate ..groupSpecification;
	end;	
	return false;
end;

function autoFruitRegistration(typeName)
end;
--print("sprung:")
loadConfig()